package usaepay;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import com.google.gson.*;
import usaepay.*;
import java.util.*;


public class paymentenginepayrequestspostTest {
	@Test public void paymentenginepayrequestspost() {
		API.setAuthentication("Example_API_Key","Example_Pin");
		API.local_test=true;

		//Building Response
		Map<String, Object> expected_response = new HashMap<String, Object>();
		expected_response.put("type","request");
		expected_response.put("key","pr_3mW7rstrdA0Sp32LW9MN3djCITAhx");
		expected_response.put("expiration","2020-07-08 16:40:48");
		expected_response.put("status","sent to device");
			Map<String, Object> transaction = new HashMap<String, Object>();
			Map<String, Object> transaction1 = new HashMap<String, Object>();
			transaction1.put("type","transaction");
			transaction1.put("key","dnfwxwhz5kvnbgb");
			transaction1.put("refnum","100061");
			transaction1.put("created","2018-12-04 10:48:44");
			transaction1.put("is_duplicate","N");
			transaction1.put("result_code","A");
			transaction1.put("result","Approved");
			transaction1.put("authcode","314407");
			transaction1.put("proc_refnum","18120443975126");
				Map<String, Object> creditcard = new HashMap<String, Object>();
				Map<String, Object> creditcard2 = new HashMap<String, Object>();
				creditcard2.put("cardholder","Minerva McGonnegall");
				creditcard2.put("number","4444xxxxxxxx1111");
				creditcard2.put("category_code","A");
				creditcard2.put("entry_mode","swiped");
				creditcard2.put("avs_street","1234 Portkey Ave");
				creditcard2.put("avs_postalcode","90006");
			transaction.put("creditcard","creditcard");
			transaction1.put("invoice","98454685");
			transaction1.put("orderid","4556432");
				Map<String, Object> avs = new HashMap<String, Object>();
				Map<String, Object> avs3 = new HashMap<String, Object>();
				avs3.put("result_code","YYY");
				avs3.put("result","Address: Match & 5 Digit Zip: Match");
			transaction.put("avs","avs");
				Map<String, Object> cvc = new HashMap<String, Object>();
				Map<String, Object> cvc4 = new HashMap<String, Object>();
				cvc4.put("result_code","N");
				cvc4.put("result","No Match");
			transaction.put("cvc","cvc");
				Map<String, Object> batch = new HashMap<String, Object>();
				Map<String, Object> batch5 = new HashMap<String, Object>();
				batch5.put("type","batch");
				batch5.put("key","ft1m9m5p9wgd9mb");
				batch5.put("batchrefnum","12345678");
				batch5.put("sequence","2902");
			transaction.put("batch","batch");
			transaction1.put("auth_amount","500.00");
			transaction1.put("trantype","Credit Card Sale");
			transaction1.put("iccdata","");
				Map<String, Object> receipts = new HashMap<String, Object>();
				Map<String, Object> receipts6 = new HashMap<String, Object>();
				receipts6.put("customer","Mail Sent Successfully");
				receipts6.put("merchant","Mail Sent Successfully");
			transaction.put("receipts","receipts");
				Map<String, Object> customer = new HashMap<String, Object>();
				Map<String, Object> customer7 = new HashMap<String, Object>();
				customer7.put("custkey","ksddgpqgpbs5zkmb");
				customer7.put("custid","10275538");
			transaction.put("customer","customer");
				Map<String, Object> savedcard = new HashMap<String, Object>();
				Map<String, Object> savedcard8 = new HashMap<String, Object>();
				savedcard8.put("type","Visa");
				savedcard8.put("key","tyet-xk8x-vpj4-7swq");
				savedcard8.put("cardnumber","4000xxxxxxxx2224");
			transaction.put("savedcard","savedcard");
		expected_response.put("transaction","transaction");
		expected_response.put("complete","sent to device");
		String encoded_response = API.json_encode(expected_response);
		MockHandler.response = encoded_response;

		//Building Request
		Map<String, Object> reqdata = new HashMap<String, Object>();
			reqdata.put("devicekey","sa_YdebDV6I2q0MfWV8kPDvQkHEvUjpA");
			reqdata.put("command","sale");
			reqdata.put("amount","2.11");
				Map<String, Object> amount_detail = new HashMap<String, Object>();
				amount_detail.put("subtotal","40.00");
				amount_detail.put("tax","10.00");
				amount_detail.put("enable_partialauth","false");
			reqdata.put("amount_detail","amount_detail");
			reqdata.put("timeout","150");
			reqdata.put("block_offline","true");
			reqdata.put("ignore_duplicate","true");
			reqdata.put("save_card","true");
			reqdata.put("manual_key","true");
			reqdata.put("prompt_tip","true");
			reqdata.put("invoice","123456");
			reqdata.put("ponum","987654321");
			reqdata.put("orderid","12345678");
			reqdata.put("description","sample description");
				Map<String, Object> billing_address = new HashMap<String, Object>();
				billing_address.put("company","Hogwarts School of Witchcraft and Wizardry");
				billing_address.put("street","123 Astronomy Tower");
				billing_address.put("postalcode","10005");
			reqdata.put("billing_address","billing_address");
				Map<String, Object> shipping_address = new HashMap<String, Object>();
				shipping_address.put("company","Hogwarts School of Witchcraft and Wizardry");
				shipping_address.put("street","123 Astronomy Tower");
				shipping_address.put("postalcode","10005");
			reqdata.put("shipping_address","shipping_address");
			List<Map> custom_fields = new ArrayList<Map>();
			reqdata.put("custom_fields",custom_fields);
			List<Map> lineitems = new ArrayList<Map>();
				Map<String, Object> LineItem = new HashMap<String, Object>();
				LineItem.put("name","Antique Pensieve");
				LineItem.put("description","See into your past...");
				LineItem.put("size","Large");
				LineItem.put("color","Bronze");
				LineItem.put("cost","450.00");
				LineItem.put("list_price","500.00");
				LineItem.put("qty","1");
				LineItem.put("sku","68453423");
				LineItem.put("commoditycode","535");
				LineItem.put("discountamount","0");
				LineItem.put("discountrate","0");
				LineItem.put("taxable","");
				LineItem.put("taxamount","45.00");
				LineItem.put("taxclass","NA");
				LineItem.put("taxrate","10");
				LineItem.put("um","EA");
				LineItem.put("category","Antiques");
				LineItem.put("manufacturer","The Ancients");
			lineitems.add(LineItem);
				Map<String, Object> LineItem9 = new HashMap<String, Object>();
				LineItem9.put("name","Antique Pensieve");
				LineItem9.put("description","See into your past...");
				LineItem9.put("size","Large");
				LineItem9.put("color","Bronze");
				LineItem9.put("cost","450.00");
				LineItem9.put("list_price","500.00");
				LineItem9.put("qty","1");
				LineItem9.put("sku","68453423");
				LineItem9.put("commoditycode","535");
				LineItem9.put("discountamount","0");
				LineItem9.put("discountrate","0");
				LineItem9.put("taxable","");
				LineItem9.put("taxamount","45.00");
				LineItem9.put("taxclass","NA");
				LineItem9.put("taxrate","10");
				LineItem9.put("um","EA");
				LineItem9.put("category","Antiques");
				LineItem9.put("manufacturer","The Ancients");
			lineitems.add(LineItem9);
			reqdata.put("lineitems",lineitems);
		String response = "";
		response = usaepay.paymentengine.Payrequests.post(reqdata);

		assertEquals("Response did not match ",encoded_response,response);
		assertEquals("Request did not match ",API.json_encode(reqdata),MockHandler.request);
		assertTrue("Path not formatted correctly "+MockHandler.path,MockHandler.path.contains("https://secure.usaepay.com/api/v2/paymentengine/payrequests"));
		assertEquals("Method did not match ","POST",MockHandler.method.toUpperCase());
	}
}